#!/usr/bin/env python2

import os,random
import vcf_tools as vcf_t
import windows_tools
import time
import sys



###This script is running the bootstraps, it will upload the list of commands to run the bootstraps. With modification it can either print this commands to scripts or launching jobs on a cluster.
#it is  dependent on some libraries, windows_tools and vcf_tools can be found here : https://github.com/ldutoit/personal_libraries

#paramters

folder_beds = "folder/" #folder that contains all the bedfile from which one wants to run the bootstraps ( typically one per type of markers)

bedfiles = [bed for bed in os.listdir(folder_beds ) if  bed.endswith(".bed")] # will create a list of the bedfiles one wants to run bootrap from

range_nbMark=range(60,201,10) # a list with the different numbers of markers to run bootstraps with
range_nbInd=[1]+  range(0,21,5)[1:] # a list with the different numbers of individuals to run bootstraps with

minNsites = maxNsites = 500 #the number of sites  that should be included in the markers ( number of sites passing the filtering (nb individuals with the minimum coverage))

bgzip = True #wether the vcf ar bgzipped or not
vcf_file_allsites = "/home/ludovic/nobackup_ludo/He_types_of_markers_clean/vcf/I.gatk.allsitesRM_sorted.vcf.gz" # vcf containing allsits
vcf_file_snps = "/home/ludovic/nobackup_ludo/He_types_of_markers_clean/vcf/I.gatk.allsitesRM_sortedsnps.vcf.gz"# vcf with confident gentypes calls
mincov=5 # the minimum coverage for a site to be considered
maxcov=10000 ## the maximum coverage for a site to be considered





#scripts



#
if not os.path.exists(output_bootstraps):
	os.mkdir(output_bootstraps)
	os.mkdir(output_bootstraps+"/logs")

for bedfile in bedfiles:
	bed=folder_beds+"/"+bedfile
	i=0
	for nbInd in range_nbInd:
		for nbMark in range_nbMark:
			print nbInd,nbMark
				print boot_job_nb
				i+=1
				output_file=output_bootstraps+"/"+(bed.split("/")[-1]).split()[0]+"_nbMark_"+str(nbMark)+"_nb_Ind"+str(nbInd)+"_"+time.strftime("%I%M__%d_%m_%Y")+"_""_bootstraps.txt"
				command="#!/usr/bin/env python 2\n"
				command+="import boot_pi\n"
				command+='boot_pi.pi_bootstraps("%s","%s","%s",nb_bootstraps=%i,seqcol=0,startcol=1,endcol=2,output_file="%s",mincov=5,maxcov=100000000,nbMark = %i,nbInd=%i,minNsites = %i,maxNsites = %i,bgzip=True)' %(bed,vcf_file_snps,vcf_file_allsites,nb_bootstraps_per_job,output_file,nbMark,nbInd,minNsites,maxNsites)
				print command



	#